#ifndef BrainFunk_h
#define BrainFunk_h

#include <QMainWindow>

class Ui_BrainFunk;
class QModelIndex;
class QPlainTextEdit;

class BrainFunk : public QMainWindow
{
  Q_OBJECT

public:
  BrainFunk(QWidget* parent = NULL);
  ~BrainFunk();

  QPlainTextEdit* editInput() const;
  QPlainTextEdit* editOutput() const;

  int length() const;

  bool saveChanges();
  void save();
  void open();

public slots:
  void changed();
  void unchanged();
  
  void on_actionNew_triggered();
  void on_actionOpen_triggered();
  void on_actionSave_triggered();
  void on_actionSaveAs_triggered();
  
  void on_actionLength_triggered();

  void on_actionTapeLength_triggered();
  void on_actionMaximumValue_triggered();
  void on_actionAlphabet_triggered(bool);

  void on_actionRun_triggered();
  void on_actionStep_triggered();
  void on_actionHalt_triggered();
  void on_buttonTest_clicked();

  void helpIndex();
  void helpAbout();

  void selectChallenge(const QModelIndex& index);

  void step(QAction*);

protected:
  void timerEvent(QTimerEvent*);
  void closeEvent(QCloseEvent*);

private:
  void continueChallenge();
  void endChallenge();

  void prepare();
  void run(int steps);
  void step(int mode);
  void start();
  void stop();
  void halt();

  void updateGUI();
  void readOutput();

  struct Private;
  Private* d;
  Ui_BrainFunk* p;
};

#endif
