#include <QApplication>
#include "BrainFunk.h"

#include "Challenges.h"
#include <QFile>
#include <QIcon>

#include <QSettings>

#include <time.h>

int main(int argc, char** argv)
{
  srand(time(NULL));

  QApplication app(argc, argv);
  QCoreApplication::setOrganizationName("ShamblesSoftware");
  QCoreApplication::setApplicationName("BrainFunk");
  app.setWindowIcon(QIcon(":/shambles.png"));

  if (app.arguments().contains("--reset"))
  {
    QSettings settings;
    settings.beginGroup("challenge");
    settings.remove("");
    settings.endGroup();
  }

  ChallengeLoader loader;

  QFile file(":/challenges.xml");
  file.open(QIODevice::ReadOnly);

  loader.setDevice(&file);
  loader.load();

  BrainFunk* bf = new BrainFunk();
  bf->show();

  return app.exec();
}
