#ifndef ChallengeHandlers_h
#define ChallengeHandlers_h

#include "IOHandler.h"

class QStringList;

class NormalTestHandler : public IOHandler
{
public:
  NormalTestHandler(BrainFunk* bf, const QStringList& data);
  ~NormalTestHandler();

  void reset();
  void refresh();

  bool hasInput();
  int input();

  bool canOutput(int output);

  bool canFinish();

private:
  struct Private;
  Private* d;
};

class AlphaTestHandler : public IOHandler
{
public:
  AlphaTestHandler(BrainFunk* bf, const QStringList& data);
  ~AlphaTestHandler();

  void reset();
  void refresh();

  bool hasInput();
  int input();

  bool canOutput(int output);

  bool canFinish();

private:
  struct Private;
  Private* d;
};

class NimTestHandler : public IOHandler
{
public:
  NimTestHandler(BrainFunk* bf);
  ~NimTestHandler();

  void reset();
  void refresh();

  bool hasInput();
  int input();

  bool canOutput(int output);

  bool canFinish();

private:
  struct Private;
  Private* d;
};

#endif
