#include "ChallengeModel.h"
#include "Challenges.h"

#include <QPixmap>
#include <QIcon>

ChallengeModel::ChallengeModel(QObject* parent) :
  QAbstractItemModel(parent)
{
}

ChallengeModel::~ChallengeModel()
{
}

int ChallengeModel::rowCount(const QModelIndex&) const
{
  return global::challenges.count();
}

QVariant ChallengeModel::data(const QModelIndex& index, int role) const
{
  if (!index.isValid())
    return QVariant();

  int x = index.column();
  int y = index.row();

  if (y >= global::challenges.count())
    return QVariant();

  if (role == Qt::DisplayRole)
  {
    if (x == 1)
      return global::challenges[y].name;
  }

  if (role == Qt::DecorationRole)
  {
    if (x == 0)
      if (global::isChallengeComplete(y))
        return QIcon(":/complete.png");

    if (x == 2)
    {
      int value = qBound(0, global::challenges[y].difficulty, 5);
      return QPixmap(QString(":/difficulty%1.png").arg(value)).scaled(24, 24, Qt::KeepAspectRatio, Qt::SmoothTransformation);
    }
  }

  return QVariant();
}
