#ifndef Challenges_h
#define Challenges_h

#include <QString>
#include <QStringList>
#include <QList>

#include <QXmlStreamReader>

class IOHandler;
class BrainFunk;

struct Challenge
{
  QString name;
  QString description;
  int difficulty;

  int tapeLength;
  int programLength;

  QString testMode;
  QStringList data;

  Challenge() :
    tapeLength(10000),
    programLength(0)
  {
  }

  IOHandler* createHandler(BrainFunk* bf) const;
};

class ChallengeLoader : public QXmlStreamReader
{
public:
  virtual ~ChallengeLoader() {}

  void load();

private:
  Challenge loadChallenge();
};

namespace global
{

extern QList<Challenge> challenges;
bool isChallengeComplete(int number);
void setChallengeComplete(int number);

}

#endif
