#ifndef IOHandler_h
#define IOHandler_h

class BrainFunk;

class IOHandler
{
public:
  IOHandler();
  virtual ~IOHandler();

  virtual void reset() {}
  virtual void refresh() {}

  virtual bool hasInput();
  virtual int input();

  virtual bool canOutput(int output);

  virtual bool canFinish();
};

class NumericHandler : public IOHandler
{
public:
  NumericHandler(BrainFunk* window);
  ~NumericHandler();

  void reset();
  void refresh();

  bool hasInput();
  int input();

  bool canOutput(int output);
  
private:
  struct Private;
  Private* d;
};

class AlphaHandler : public IOHandler
{
public:
  AlphaHandler(BrainFunk* window);
  ~AlphaHandler();

  void reset();
  void refresh();

  bool hasInput();
  int input();

  bool canOutput(int output);

private:
  struct Private;
  Private* d;
};

#endif
