#ifndef ProgramHighlighter_h
#define ProgramHighlighter_h

#include <QSyntaxHighlighter>

class ProgramHighlighter : public QSyntaxHighlighter
{
  Q_OBJECT

public:
  enum HighlightCode
  {
    NoHighlight,
    HighlightMove,
    HighlightChange,
    HighlightControl,
    HighlightIO,
  };

  ProgramHighlighter(QTextDocument* parent);
  ~ProgramHighlighter();

  void setExecutionPosition(int position);

  void highlightBlock(const QString& text);

private:
  void applyCode(HighlightCode what, int from, int length);
  void applyTally(QTextCharFormat& regular, QTextCharFormat& tally, int from, int length);
  HighlightCode code(QChar letter);

  struct Private;
  Private* d;
};

#endif
