#ifndef TapeModel_h
#define TapeModel_h

#include <QAbstractItemModel>
class Machine;

class TapeModel : public QAbstractItemModel
{
  Q_OBJECT

public:
  TapeModel(QObject* parent = NULL);
  TapeModel(Machine* machine, QObject* parent = NULL);
  ~TapeModel();

  void setMachine(Machine* machine);

  int columnCount(const QModelIndex& parent = QModelIndex()) const;
  int rowCount(const QModelIndex& = QModelIndex()) const
  {
    return 1;
  }

  QModelIndex index(int row, int column, const QModelIndex& = QModelIndex()) const
  {
    return createIndex(row, column);
  }

  QModelIndex parent(const QModelIndex&) const
  {
    return QModelIndex();
  }

  QModelIndex positionIndex() const;

  QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;

  void tapeChanged()
  {
    reset();
  }

private:
  Machine* machine;
};

#endif
